import { NextResponse as d } from "next/server";
import { config as r, routes as _ } from "../config/index.es.js";
import { jwtDecoder as D } from "@kinde/jwt-decoder";
import { isTokenExpired as C } from "../utils/jwt/validation.es.js";
import { getAccessToken as V } from "../utils/getAccessToken.es.js";
import { kindeClient as B } from "../session/kindeServerClient.es.js";
import { sessionManager as E } from "../session/sessionManager.es.js";
import { getSplitCookies as A } from "../utils/cookies/getSplitSerializedCookies.es.js";
import { getIdToken as I } from "../utils/getIdToken.es.js";
import { copyCookiesToRequest as z } from "../utils/copyCookiesToRequest.es.js";
import { getStandardCookieOptions as j } from "../utils/cookies/getStandardCookieOptions.es.js";
const P = async (t, e, l) => {
  const { pathname: c } = t.nextUrl, f = e == null ? void 0 : e.isReturnToCurrentPage, h = e == null ? void 0 : e.orgCode, g = (e == null ? void 0 : e.loginPage) || `${r.apiPath}/${_.login}`, v = `${r.apiPath}/kinde_callback`, $ = `${r.apiPath}/${_.register}`, x = `${r.apiPath}/${_.setup}`;
  if (g == c || v == c || $ == c || x == c)
    return d.next();
  let U = ["/_next", "/favicon.ico"];
  (e == null ? void 0 : e.publicPaths) !== void 0 && Array.isArray(e == null ? void 0 : e.publicPaths) && (U = e.publicPaths);
  const M = new URLSearchParams();
  h && M.set("org_code", h), f && M.set("post_login_redirect_url", c);
  const y = M.toString(), k = y ? `${g}?${y}` : g, R = U.some((i) => i === "/" ? c === "/" : c.startsWith(i));
  let m = await V(t), w = await I(t);
  if ((!m || !w) && !R)
    return r.isDebugMode && console.log(
      "authMiddleware: no access or id token, redirecting to login"
    ), d.redirect(
      new URL(k, (e == null ? void 0 : e.redirectURLBase) || r.redirectURL)
    );
  const S = await E(t);
  let s = null;
  const n = d.next();
  if (C(m) || C(w)) {
    r.isDebugMode && console.log("authMiddleware: access token expired, refreshing");
    const i = (a) => {
      if (r.isDebugMode && console.error(a), !R)
        return d.redirect(
          new URL(
            k,
            (e == null ? void 0 : e.redirectURLBase) || r.redirectURL
          )
        );
    };
    try {
      s = await B.refreshTokens(S, !1), m = s.access_token, w = s.id_token, r.isDebugMode && console.log(
        "authMiddleware: tokens refreshed",
        !!s.access_token,
        !!s.id_token
      );
    } catch {
      return i("authMiddleware: error refreshing tokens");
    }
    try {
      A(
        "access_token",
        s.access_token
      ).forEach((o) => {
        n.cookies.set(o.name, o.value, o.options);
      }), A(
        "id_token",
        s.id_token
      ).forEach((o) => {
        n.cookies.set(o.name, o.value, o.options);
      }), n.cookies.set(
        "refresh_token",
        s.refresh_token,
        j()
      ), z(t, n), r.isDebugMode && console.log("authMiddleware: tokens refreshed and cookies updated");
    } catch {
      i("authMiddleware: error settings new token in cookie");
    }
  }
  if (R)
    return n;
  let b = null, u = null;
  try {
    b = D(m);
  } catch {
    return r.isDebugMode && console.error(
      "authMiddleware: access token decode failed, redirecting to login"
    ), d.redirect(
      new URL(k, (e == null ? void 0 : e.redirectURLBase) || r.redirectURL)
    );
  }
  try {
    u = D(w);
  } catch {
    return r.isDebugMode && console.error(
      "authMiddleware: id token decode failed, redirecting to login"
    ), d.redirect(
      new URL(k, (e == null ? void 0 : e.redirectURLBase) || r.redirectURL)
    );
  }
  const L = e != null && e.isAuthorized ? e.isAuthorized({ req: t, token: b }) : !0;
  if (L && l) {
    r.isDebugMode && console.log("authMiddleware: invoking onSuccess callback");
    const i = await l({
      token: b,
      user: {
        family_name: u.family_name,
        given_name: u.given_name,
        email: u.email,
        id: u.sub,
        picture: u.picture
      }
    });
    return i instanceof d ? (r.isDebugMode && console.log(
      "authMiddleware: onSuccess callback returned a response, copying our cookies to it"
    ), n.cookies.getAll().forEach((a) => {
      i.cookies.set(a.name, a.value, {
        ...a
      });
    }), n.headers.forEach((a, T) => {
      i.headers.set(T, a);
    }), i) : (r.isDebugMode && console.log(
      "authMiddleware: onSuccess callback did not return a response, returning our response"
    ), n);
  }
  return L ? (r.isDebugMode && console.log(
    "authMiddleware: customValidationValid is true, returning response"
  ), n) : (r.isDebugMode && console.log("authMiddleware: default behaviour, redirecting to login"), d.redirect(
    new URL(k, (e == null ? void 0 : e.redirectURLBase) || r.redirectURL)
  ));
};
function Z(...t) {
  if (!t.length || t[0] instanceof Request)
    return P(...t);
  if (typeof t[0] == "function") {
    const l = t[0], c = t[1];
    return async (...f) => await P(f[0], c, async ({ token: h, user: g }) => (f[0].kindeAuth = { token: h, user: g }, await l(...f)));
  }
  const e = t[0];
  return async (...l) => await P(l[0], e);
}
export {
  Z as withAuth
};
