import { jwtDecoder as k } from "@kinde/jwt-decoder";
import { config as i } from "../config/index.es.js";
import { generateUserObject as M } from "../utils/generateUserObject.es.js";
import { getAccessToken as y } from "../utils/getAccessToken.es.js";
import { getIdToken as h } from "../utils/getIdToken.es.js";
import { isTokenExpired as E } from "../utils/jwt/validation.es.js";
import { sessionManager as j } from "../session/sessionManager.es.js";
import { kindeClient as N } from "../session/kindeServerClient.es.js";
import { RequestQueueManager as b } from "../utils/workQueue.es.js";
const K = async (o) => b.getInstance().enqueue(async () => {
  var d, _, u, g, m, f;
  try {
    let n = await y(o.req), r = await h(o.req);
    if (!n || !r)
      return i.isDebugMode && console.log("setup: no access or id token - returning NOT_LOGGED_IN"), o.json(
        {
          message: "NOT_LOGGED_IN"
        },
        { status: 200 }
      );
    const D = await j(o.req);
    if (E(n) || E(r)) {
      i.isDebugMode && console.log("setup: access or id token expired - attempting refresh");
      try {
        const s = await N.refreshTokens(D);
        n = s.access_token, r = s.id_token;
      } catch (s) {
        return i.isDebugMode && console.error("setup: refresh tokens failed - returning error"), o.json(
          { message: "REFRESH_FAILED", error: s },
          { status: 500 }
        );
      }
    }
    let t = null, a = null;
    try {
      t = k(n);
    } catch (s) {
      return i.isDebugMode && console.error(
        "setup: access token decode failed, redirecting to login"
      ), o.json(
        { message: "ACCESS_TOKEN_DECODE_FAILED", error: s },
        { status: 500 }
      );
    }
    try {
      a = k(r);
    } catch (s) {
      return i.isDebugMode && console.error("setup: id token decode failed, redirecting to login"), o.json(
        { message: "ID_TOKEN_DECODE_FAILED", error: s },
        { status: 500 }
      );
    }
    if (!t || !a)
      return o.json(
        { message: "TOKENS_MISSING", error: "No access or id token" },
        { status: 500 }
      );
    const l = t.permissions, p = t.org_code, T = t.feature_flags, O = a.org_codes, I = t.org_name, e = t.organization_properties, c = a.organizations;
    return o.json({
      accessToken: t,
      accessTokenEncoded: n,
      accessTokenRaw: n,
      idToken: a,
      idTokenRaw: r,
      idTokenEncoded: r,
      user: M(a, t),
      permissions: {
        permissions: l,
        orgCode: p
      },
      needsRefresh: !1,
      message: "OK",
      organization: {
        orgCode: p,
        orgName: I,
        properties: {
          city: (d = e == null ? void 0 : e.kp_org_city) == null ? void 0 : d.v,
          industry: (_ = e == null ? void 0 : e.kp_org_industry) == null ? void 0 : _.v,
          postcode: (u = e == null ? void 0 : e.kp_org_postcode) == null ? void 0 : u.v,
          state_region: (g = e == null ? void 0 : e.kp_org_state_region) == null ? void 0 : g.v,
          street_address: (m = e == null ? void 0 : e.kp_org_street_address) == null ? void 0 : m.v,
          street_address_2: (f = e == null ? void 0 : e.kp_org_street_address_2) == null ? void 0 : f.v
        }
      },
      featureFlags: T,
      userOrganizations: {
        orgCodes: O,
        orgs: c == null ? void 0 : c.map((s) => ({
          code: s == null ? void 0 : s.id,
          name: s == null ? void 0 : s.name
        }))
      }
    });
  } catch (n) {
    return i.isDebugMode && console.error("setup: failed, error: ", n), o.json(
      {
        message: "SETUP_FAILED",
        error: n
      },
      { status: 500 }
    );
  }
});
export {
  K as setup
};
