import { cookies as u } from "next/headers";
import { isAppRouter as k } from "../utils/isAppRouter.es.js";
import { config as a } from "../config/index.es.js";
import { COOKIE_LIST as l, GLOBAL_COOKIE_OPTIONS as m, TWENTY_NINE_DAYS as d, MAX_COOKIE_LENGTH as p } from "../utils/constants.es.js";
import { splitString as S } from "../utils/splitString.es.js";
import * as f from "cookie";
const y = async (n, o) => {
  try {
    if (!n) {
      const e = await u();
      return g(e);
    }
    if (k(n)) {
      const e = await u(n, o);
      return g(e);
    } else
      return h(n, o);
  } catch (e) {
    throw e;
  }
}, g = (n) => ({
  /**
   *
   * @param {string} itemKey
   * @returns {Promise<string | object | null>}
   */
  getSessionItem: (o) => {
    const e = n.get(o);
    if (!e) return null;
    try {
      let i = "", t = 0, r = `${String(o)}${t === 0 ? "" : t}`;
      for (; n.has(r); )
        i += n.get(r).value, t++, r = `${String(o)}${t === 0 ? "" : t}`;
      try {
        const s = JSON.parse(i);
        if (typeof s == "object")
          return s;
      } catch {
      }
      return i;
    } catch (i) {
      return a.isDebugMode && console.error("Failed to parse session item app router:", i), e.value;
    }
  },
  /**
   *
   * @param {string} itemKey
   * @param {any} itemValue
   * @returns {Promise<void>}
   */
  setSessionItem: (o, e) => {
    if (n.getAll().map((i) => i.name).forEach((i) => {
      i.startsWith(`${String(o)}`) && n.delete(i);
    }), e !== void 0) {
      const i = typeof e == "object" ? JSON.stringify(e) : e;
      S(i, p).forEach(
        (t, r) => {
          n.set(o + (r === 0 ? "" : r), t, {
            maxAge: d,
            domain: a.cookieDomain ? a.cookieDomain : void 0,
            ...m
          });
        }
      );
    }
  },
  /**
   *
   * @param {string} itemKey
   * @returns {Promise<void>}
   */
  removeSessionItem: (o) => {
    n.getAll().map((e) => e.name).forEach((e) => {
      e.startsWith(`${String(o)}`) && n.delete(e);
    });
  },
  /**
   * @returns {Promise<void>}
   */
  destroySession: () => {
    n.getAll().map((o) => o.name).forEach((o) => {
      l.some((e) => o.startsWith(e)) && n.set(o, "", {
        domain: a.cookieDomain ? a.cookieDomain : void 0,
        maxAge: 0,
        ...m
      });
    });
  }
}), h = (n, o) => ({
  /**
   *
   * @param {string} itemKey
   * @returns {Promise<string | undefined>}
   */
  getSessionItem: (e) => {
    const i = n.cookies[e];
    if (i)
      try {
        let t = "", r = 0, s = `${String(e)}${r === 0 ? "" : r}`;
        for (; n.cookies[s]; )
          t += n.cookies[s], r++, s = `${String(e)}${r === 0 ? "" : r}`;
        try {
          const c = JSON.parse(t);
          if (typeof c == "object")
            return c;
        } catch (c) {
          a.isDebugMode && console.error("Failed to parse session item:", c);
        }
        return t;
      } catch (t) {
        return a.isDebugMode && console.error("Failed to read session item:", t), i;
      }
  },
  /**
   *
   * @param {string} itemKey
   * @param {any} itemValue
   * @returns {Promise<void>}
   */
  setSessionItem: (e, i) => {
    let t = (o == null ? void 0 : o.getHeader("Set-Cookie")) || [];
    if (Array.isArray(t) || (t = [t.toString()]), n.cookies[e] !== void 0 && t.push(
      f.serialize(e, "", {
        domain: a.cookieDomain ? a.cookieDomain : void 0,
        maxAge: -1,
        ...m
      })
    ), i !== void 0) {
      const r = typeof i == "object" ? JSON.stringify(i) : i;
      o == null || o.setHeader(
        "Set-Cookie",
        [
          ...t.filter((s) => !s.startsWith(`${e}`)) || [],
          ...S(r, p).map(
            (s, c) => f.serialize(
              e + (c === 0 ? "" : c),
              s,
              {
                domain: a.cookieDomain ? a.cookieDomain : void 0,
                ...m,
                maxAge: d
              }
            )
          )
        ],
        {
          domain: a.cookieDomain ? a.cookieDomain : void 0,
          ...m,
          maxAge: d
        }
      );
    }
  },
  /**
   *
   * @param {string} itemKey
   * @returns {Promise<void>}
   */
  removeSessionItem: (e) => {
    let i = (o == null ? void 0 : o.getHeader("Set-Cookie")) || [];
    Array.isArray(i) || (i = [i.toString()]), n.cookies[e] !== void 0 && i.push(
      f.serialize(e, "", {
        domain: a.cookieDomain ? a.cookieDomain : void 0,
        maxAge: -1,
        ...m
      })
    ), o == null || o.setHeader("Set-Cookie", [
      ...i.map((t) => t.startsWith(`${e}`) ? f.serialize(t.split("=")[0], "", {
        domain: a.cookieDomain ? a.cookieDomain : void 0,
        maxAge: -1,
        ...m
      }) : t)
    ]);
  },
  destroySession: () => {
    let e = (o == null ? void 0 : o.getHeader("Set-Cookie")) || [];
    Array.isArray(e) || (e = [e.toString()]), o == null || o.setHeader("Set-Cookie", [
      ...Object.keys(n.cookies).map((i) => {
        if (l.some((t) => i.startsWith(t)))
          return f.serialize(i.split("=")[0], "", {
            domain: a.cookieDomain ? a.cookieDomain : void 0,
            maxAge: -1,
            ...m
          });
      })
    ]);
  }
});
export {
  g as appRouterSessionManager,
  h as pageRouterSessionManager,
  y as sessionManager
};
