import { NextResponse } from 'next/server';
export default class RouterClient {
    /** @type {import('../types').KindeClientConfig} */
    clientConfig: import('../types').KindeClientConfig;
    /** @type {import('../types').KindeClient} */
    kindeClient: import('../types').KindeClient;
    /** @type {URL} */
    url: URL;
    /** @type {import('@kinde-oss/kinde-typescript-sdk').SessionManager} */
    sessionManager: import('@kinde-oss/kinde-typescript-sdk').SessionManager;
    /** @type {import('next').NextApiResponse | *} */
    res: import('next').NextApiResponse | any;
    /** @type {import('next').NextApiRequest | NextResponse | *} */
    req: import('next').NextApiRequest | NextResponse | any;
    /** @type {URLSearchParams} */
    searchParams: URLSearchParams;
    /**
     *
     * @param {string} url
     * @returns
     */
    redirect(url: string): void;
    /**
     *
     * @param {object} data
     * @param {{status: number}} [status]
     * @returns
     */
    json(data: object, status?: {
        status: number;
    }): void;
    error(): void;
    /**
     *
     * @returns {URL}
     */
    getUrl(): URL;
    /**
     *
     * @param {string} key
     * @returns {string | null}
     */
    getSearchParam(key: string): string | null;
    onError(): void;
}
//# sourceMappingURL=RouterClient.d.ts.map